

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>oxD Python Library Documentation &mdash; oxD Python 2.4.4-rc documentation</title>
  

  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
  

  

  
    <link rel="top" title="oxD Python 2.4.4-rc documentation" href="#"/> 

  
  <script src="_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="#" class="icon icon-home"> oxD Python
          

          
          </a>

          
            
            
              <div class="version">
                2.4.4
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <!-- Local TOC -->
                <div class="local-toc"><ul>
<li><a class="reference internal" href="#">oxD Python Library Documentation</a></li>
</ul>
</div>
            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="#">oxD Python</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          

 



<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="#">Docs</a> &raquo;</li>
      
    <li>oxD Python Library Documentation</li>
      <li class="wy-breadcrumbs-aside">
        
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="oxd-python-library-documentation">
<h1>oxD Python Library Documentation<a class="headerlink" href="#oxd-python-library-documentation" title="Permalink to this headline">¶</a></h1>
<p>Welcome to the oxD Python API reference page. If you are looking for docs on how to use the library <a class="reference external" href="https://oxd.gluu.org/docs/plugin/python/">go here</a>.</p>
<span class="target" id="module-oxdpython.client"></span><dl class="class">
<dt id="oxdpython.client.Client">
<em class="property">class </em><code class="descclassname">oxdpython.client.</code><code class="descname">Client</code><span class="sig-paren">(</span><em>config_location</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/oxdpython/client.html#Client"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#oxdpython.client.Client" title="Permalink to this definition">¶</a></dt>
<dd><p>Client is the main class that carries out the commands to talk with the
oxD server. The oxD request commands are provided as class methods that
can be called to send the command to the oxD server via socket and the
reponse is returned as a dict by the called method.</p>
<dl class="method">
<dt id="oxdpython.client.Client.get_authorization_url">
<code class="descname">get_authorization_url</code><span class="sig-paren">(</span><em>acr_values=None</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/oxdpython/client.html#Client.get_authorization_url"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#oxdpython.client.Client.get_authorization_url" title="Permalink to this definition">¶</a></dt>
<dd><p>Function to get the authorization url that can be opened in the
browser for the user to provide authorization and authentication</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>acr_values</strong> (<em>list, optional</em>) &#8211; acr values in the order of priority</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body">The authorization url that the user must access for
authentication and authorization</td>
</tr>
<tr class="field-odd field"><th class="field-name">Return type:</th><td class="field-body">string</td>
</tr>
<tr class="field-even field"><th class="field-name">Raises:</th><td class="field-body"><code class="xref py py-exc docutils literal"><span class="pre">RuntimeError</span></code> &#8211; If the oxD throws an error for any reason.</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="oxdpython.client.Client.get_logout_uri">
<code class="descname">get_logout_uri</code><span class="sig-paren">(</span><em>id_token_hint=None</em>, <em>post_logout_redirect_uri=None</em>, <em>state=None</em>, <em>session_state=None</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/oxdpython/client.html#Client.get_logout_uri"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#oxdpython.client.Client.get_logout_uri" title="Permalink to this definition">¶</a></dt>
<dd><p>Function to logout the user.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first simple">
<li><strong>id_token_hint</strong> (<em>string, optional</em>) &#8211; oxd server will use last used
ID Token, if not provided</li>
<li><strong>post_logout_redirect_uri</strong> (<em>string, optional</em>) &#8211; URI to redirect,
this uri would override the value given in the site-config</li>
<li><strong>state</strong> (<em>string, optional</em>) &#8211; site state</li>
<li><strong>session_state</strong> (<em>string, optional</em>) &#8211; session state</li>
</ul>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first">The URI to which the user must be directed in order to
perform the logout</p>
</td>
</tr>
<tr class="field-odd field"><th class="field-name">Return type:</th><td class="field-body"><p class="first last">string</p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="oxdpython.client.Client.get_tokens_by_code">
<code class="descname">get_tokens_by_code</code><span class="sig-paren">(</span><em>code</em>, <em>scopes</em>, <em>state=None</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/oxdpython/client.html#Client.get_tokens_by_code"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#oxdpython.client.Client.get_tokens_by_code" title="Permalink to this definition">¶</a></dt>
<dd><p>Function to get access code for getting the user details from the
OP. It is called after the user authorizies by visiting the auth URL.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first simple">
<li><strong>code</strong> (<em>string</em>) &#8211; code, parse from the callback URL querystring</li>
<li><strong>scopes</strong> (<em>list</em>) &#8211; scopes authorized by the OP, parsed from the
callback URL</li>
<li><strong>state</strong> (<em>string, optional</em>) &#8211; state, parsed from the callback URL</li>
</ul>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><p>The tokens object with the following data structure:</p>
<div class="highlight-python"><div class="highlight"><pre><span></span><span class="p">{</span>
    <span class="s2">&quot;access_token&quot;</span><span class="p">:</span> <span class="s2">&quot;&lt;token string&gt;&quot;</span><span class="p">,</span>
    <span class="s2">&quot;expires_in&quot;</span><span class="p">:</span> <span class="mi">3600</span><span class="p">,</span>
    <span class="s2">&quot;refresh_token&quot;</span><span class="p">:</span> <span class="s2">&quot;&lt;token string&gt;&quot;</span><span class="p">,</span>
    <span class="s2">&quot;id_token&quot;</span><span class="p">:</span> <span class="s2">&quot;&lt;token string&gt;&quot;</span><span class="p">,</span>
    <span class="s2">&quot;id_token_claims&quot;</span><span class="p">:</span>
    <span class="p">{</span>
        <span class="s2">&quot;iss&quot;</span><span class="p">:</span> <span class="s2">&quot;https://server.example.com&quot;</span><span class="p">,</span>
        <span class="s2">&quot;sub&quot;</span><span class="p">:</span> <span class="s2">&quot;24400320&quot;</span><span class="p">,</span>
        <span class="s2">&quot;aud&quot;</span><span class="p">:</span> <span class="s2">&quot;s6BhdRkqt3&quot;</span><span class="p">,</span>
        <span class="s2">&quot;nonce&quot;</span><span class="p">:</span> <span class="s2">&quot;n-0S6_WzA2Mj&quot;</span><span class="p">,</span>
        <span class="s2">&quot;exp&quot;</span><span class="p">:</span> <span class="mi">1311281970</span><span class="p">,</span>
        <span class="s2">&quot;iat&quot;</span><span class="p">:</span> <span class="mi">1311280970</span><span class="p">,</span>
        <span class="s2">&quot;at_hash&quot;</span><span class="p">:</span> <span class="s2">&quot;MTIzNDU2Nzg5MDEyMzQ1Ng&quot;</span>
    <span class="p">}</span>
<span class="p">}</span>
</pre></div>
</div>
<p>Since this would be returned as a NamedTuple, it can be accessed
using the dot notation as <code class="xref py py-obj docutils literal"><span class="pre">data.access_token</span></code>,
<code class="xref py py-obj docutils literal"><span class="pre">data.refresh_token</span></code>, <code class="xref py py-obj docutils literal"><span class="pre">data.id_token</span></code>...etc.,</p>
</p>
</td>
</tr>
<tr class="field-odd field"><th class="field-name">Return type:</th><td class="field-body"><p class="first">NamedTuple</p>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Raises:</th><td class="field-body"><p class="first last"><code class="xref py py-exc docutils literal"><span class="pre">RuntimeError</span></code> &#8211; If oxD server throws an error OR if the params code
and scopes are of improper datatype.</p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="oxdpython.client.Client.get_user_info">
<code class="descname">get_user_info</code><span class="sig-paren">(</span><em>access_token</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/oxdpython/client.html#Client.get_user_info"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#oxdpython.client.Client.get_user_info" title="Permalink to this definition">¶</a></dt>
<dd><p>Function to get the information about the user using the access code
obtained from the OP</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>access_token</strong> (<em>string</em>) &#8211; access token from the get_tokens_by_code
function</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body">The user data claims that are returned by the OP.
Refer to the /.well-known/openid-configuration URL of your OP for
the complete list of the claims for different scopes.</td>
</tr>
<tr class="field-odd field"><th class="field-name">Return type:</th><td class="field-body">NamedTuple</td>
</tr>
<tr class="field-even field"><th class="field-name">Raises:</th><td class="field-body"><code class="xref py py-exc docutils literal"><span class="pre">RuntimeError</span></code> &#8211; If the param access_token is empty OR if the oxD
Server returns an error.</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="oxdpython.client.Client.register_site">
<code class="descname">register_site</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/oxdpython/client.html#Client.register_site"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#oxdpython.client.Client.register_site" title="Permalink to this definition">¶</a></dt>
<dd><p>Function to register the site and generate a unique ID for the site</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Returns:</th><td class="field-body">The ID of the site (also called client id) if the
registration is sucessful</td>
</tr>
<tr class="field-even field"><th class="field-name">Return type:</th><td class="field-body">string</td>
</tr>
<tr class="field-odd field"><th class="field-name">Raises:</th><td class="field-body"><code class="xref py py-exc docutils literal"><span class="pre">RuntimeError</span></code> &#8211; If the site registration fails.</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="oxdpython.client.Client.update_site_registration">
<code class="descname">update_site_registration</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/oxdpython/client.html#Client.update_site_registration"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#oxdpython.client.Client.update_site_registration" title="Permalink to this definition">¶</a></dt>
<dd><p>Fucntion to update the site&#8217;s information with OpenID Provider.
This should be called after changing the values in the cfg file.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Returns:</th><td class="field-body">The status for update. True for success and False for failure</td>
</tr>
<tr class="field-even field"><th class="field-name">Return type:</th><td class="field-body">bool</td>
</tr>
</tbody>
</table>
</dd></dl>

</dd></dl>

</div>


           </div>
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2016, Gluu.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'./',
            VERSION:'2.4.4-rc',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="_static/jquery.js"></script>
      <script type="text/javascript" src="_static/underscore.js"></script>
      <script type="text/javascript" src="_static/doctools.js"></script>

  

  
  
    <script type="text/javascript" src="_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>